<?php
// $Id: subdomain_mode_group.inc,v 1.1.2.2 2010/09/05 05:38:18 setvik Exp $

/**
 * @file
 * Subdomain engine OG mode subclass
 */

/**
 * Description of subdomain_group
 *
 * @author setvik
 */
class subdomain_mode_group extends subdomain_engine {

  function type() {
    return 'node';
  }

  function base_path($sid) {
    return 'node/'. $sid;
  }

  function default_form_field() {
    return 'title';
  }

  function is_entry_form($form_id) {
    // TODO update to select correct og group node type if multiple
    if (substr($form_id, -10) == '_node_form') {
      return og_is_group_type(substr($form_id, 0, -10));
    }
    return FALSE;
  }

  function entry_form_alter(&$form, $form_id) {
    global $user;
    $default = $form['#node']->subdomain->subdomain;
    $form['subdomain_exists'] = array(
      '#type' => 'value',
      '#value' => !empty($default),
    );

    if ($this->source == 'custom') {
      $editable = user_access('edit any subdomains')
      || (user_access('edit own subdomains') && $user->uid == $form['uid']['#value']);
      $form['subdomain'] = _subdomain_get_custom_form_field($default, $editable);
    }
    _subdomain_add_js_validation("edit-$this->form_field", $form['#nid']);
  }


  function lookup($type, $object, $id) {
    if ($type == 'node' && og_is_group_type($object->type)) {
      $subdomain = subdomain_get_subdomain($id);
    }
    else {
      $subdomain = subdomain_get_content_subdomain($id, $type);
    }
    return $subdomain;
  }

  function save($type, $object, $id) {
    if ($type == 'node') {
      if (og_is_group_type($object->type)) {
        subdomain_save_subdomain($id, subdomain_clean($object->{$this->form_field}), !$object->subdomain_exists);

        // URL cache clear needed b/c url is cached before subdomain is saved resulting in skewed redirect: http://subdomain.example.com/node/xxxx instead of http://subdomain.example.com/
        subdomain_url_outbound_cache_clear();
      }
      elseif (count($object->og_groups)) {
        subdomain_save_subdomain_content($id, array_shift(array_keys($object->og_groups)), $type);
      }
    }
  }

  function delete($type, $object, $id) {
    if ($type == 'node' && og_is_group_type($object->type)) {
      subdomain_delete_subdomain($id);
    }
    else {
      subdomain_delete_subdomain_cotent($id, $type);
    }
  }

  function url_outbound_helper(&$subdomain, &$path, $original_path, &$is_system_path) {
    if ($nid = _subdomain_id_from_path('nid', $original_path)) {
      $subdomain = subdomain_get_subdomain($nid)->subdomain;
      if (empty($subdomain)) {
        $subdomain = subdomain_get_content_subdomain($nid, 'node');
      }
      elseif ($path == $this->base_path($nid)) {
        $path = '';
      }
    }
    else {
      $is_system_path = TRUE;
    }
  }
}