<?php
// $Id: subdomain_mode_term.inc,v 1.1.2.2 2010/09/05 05:38:18 setvik Exp $

/**
 * @file
 * Subdomain engine term mode subclass
 */


/**
 * Description of subdomain_term
 *
 * @author setvik
 */
class subdomain_mode_term extends subdomain_engine {

  function type() {
    return 'term';
  }

  function base_path($sid) {
    return 'taxonomy/term/'. $sid;
  }

  function is_entry_form($form_id) {
    return $form_id == 'taxonomy_form_term';
  }

  function entry_form_alter(&$form, $form_id) {
    if ($form['#vocabulary']['vid'] == variable_get('subdomain_vocab', 0)
    && !($form['delete']['#type'] == 'value' && $form['delete']['#value'] == TRUE)) {
      $default = subdomain_get_subdomain($form['tid']['#value'])->subdomain;
      $form['subdomain_exists'] = array(
        '#type' => 'value',
        '#value' => !empty($default),
      );

      if ($this->source == 'custom') {
        $form['identification']['name']['#weight'] = -5.1;

        $editable = user_access('edit any subdomains') || user_access('edit own subdomains');
        $form['identification']['subdomain'] = _subdomain_get_custom_form_field($default, $editable);
      }
      _subdomain_add_js_validation("edit-$this->form_field", $form['tid']['#value']);
    }
  }

  function lookup($type, $object, $id) {
    switch ($type) {
      case 'term':
        $subdomain = subdomain_get_subdomain($id);
        break;
      default:
        $subdomain = subdomain_get_content_subdomain($id, $type);
        break;
    }
    return $subdomain;
  }

  function save($type, $object, $id) {
    switch ($type) {
      case 'term':
        if ($object['vid'] == variable_get('subdomain_vocab', 0)) {
          subdomain_save_subdomain($id, subdomain_clean($object[$this->form_field]), !$object['subdomain_exists']);
        }
        break;

      case 'node':
        subdomain_save_subdomain_content($id, reset($object->taxonomy), 'node');
        break;
    }
  }

  function delete($type, $object, $id) {
    if ($type == 'user') {
      subdomain_delete_subdomain($id);
    }
    else {
      subdomain_delete_subdomain_cotent($id, $type);
    }
  }

  function url_outbound_helper(&$subdomain, &$path, $original_path, &$is_system_path) {
    if ($uid = _subdomain_id_from_path('tid', $original_path)) {
      $subdomain = subdomain_get_subdomain($uid)->subdomain;
      if (!empty($subdomain) && $path == $this->base_path($uid)) {
        $path = '';
      }
    }
    elseif ($nid = _subdomain_id_from_path('nid', $original_path)) {
      $subdomain = subdomain_get_content_subdomain($nid, 'node');
    }
    else {
      $is_system_path = TRUE;
    }
  }
}