<?php
// $Id: subdomain_mode_user.inc,v 1.1.2.2 2010/09/05 05:38:18 setvik Exp $

/**
 * @file
 * Subdomain engine user mode subclass
 */


/**
 * Description of subdomain_user
 *
 * @author setvik
 */
class subdomain_mode_user extends subdomain_engine {

  function type() {
    return 'user';
  }

  function base_path($sid) {
    return 'user/'. $sid;
  }

  function is_entry_form($form_id) {
    return in_array($form_id, array('user_register', 'user_profile_form'));
  }

  function entry_form_alter(&$form, $form_id) {
    global $user;

    $default = $form['_account']['#value']->subdomain->subdomain;
    $form['subdomain_exists'] = array(
      '#type' => 'value',
      '#value' => !empty($default),
    );

    if ($this->source == 'custom') {
      if (isset($form['account'])) {
        $parent = &$form['account'];
      }
      else {
        $parent = &$form;
      }
      $parent['name']['#weight'] = -5.1;

      $editable = $form_id == 'user_register'
        || user_access('edit any subdomains')
        || (user_access('edit own subdomains') && $user->uid == $form['#uid']);
      $parent['subdomain'] = _subdomain_get_custom_form_field($default, $editable);
    }
    _subdomain_add_js_validation("edit-$this->form_field", $form['#uid']);
  }

  function lookup($type, $object, $id) {
    switch ($type) {
      case 'user':
        $subdomain = subdomain_get_subdomain($id);
        break;
      default:
        $subdomain = subdomain_get_content_subdomain($id, $type);
        break;
    }
    return $subdomain;
  }

  function save($type, $object, $id) {
    switch ($type) {
      case 'user':
        subdomain_save_subdomain($id, subdomain_clean($object[$this->form_field]), !$object['subdomain_exists']);
        break;

      case 'node':
        subdomain_save_subdomain_content($id, $object->uid, 'node');
        break;
    }
  }

  function delete($type, $object, $id) {
    if ($type == 'user') {
      subdomain_delete_subdomain($id);
    }
    else {
      subdomain_delete_subdomain_cotent($id, $type);
    }
  }

  function url_outbound_helper(&$subdomain, &$path, $original_path, &$is_system_path) {
    if ($uid = _subdomain_id_from_path('uid', $original_path)) {
      $subdomain = subdomain_get_subdomain($uid)->subdomain;
      if (!empty($subdomain) && $path == $this->base_path($uid)) {
        $path = '';
      }
    }
    elseif ($nid = _subdomain_id_from_path('nid', $original_path)) {
      $subdomain = subdomain_get_content_subdomain($nid, 'node');
    }
    else {
      $is_system_path = TRUE;
    }
  }
}